PingOne Platform APIs

Update Email Content

 

PUT {{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}

The PUT {{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}} operation updates an existing customized content resource associated with the template specified in the request URL.

In addition, the variables restrictions should apply.

Before you create or update a custom content, you should always do a GET Read One Template on the notification template to determine its supported variables.

Prerequisites

  • Refer to Notifications for important overview information.

  • Use Read All Templates to retrieve a list of all notifications templates associated with the environment and select the specific templateName for the endpoint. For more information, refer to Notifications Templates.

Request Model
Property Type Required?

body

String

Required

deliveryMethod

String

Required

locale

String

Required

subject

String

Optional

Refer to the Notifications templates property data models for full property descriptions.

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

Body

raw ( application/json )

{
    "locale": "en",
    "variant": "variant_C",
    "template": {
        "id": "transaction"
    },
    "subject": "PingOne: transaction approval",
    "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "default": true
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff --request PUT '{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "locale": "en",
    "variant": "variant_C",
    "template": {
        "id": "transaction"
    },
    "subject": "PingOne: transaction approval",
    "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "default": true
}'
var options = new RestClientOptions("{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""locale"": ""en""," + "\n" +
@"    ""variant"": ""variant_C""," + "\n" +
@"    ""template"": {" + "\n" +
@"        ""id"": ""transaction""" + "\n" +
@"    }," + "\n" +
@"    ""subject"": ""PingOne: transaction approval""," + "\n" +
@"    ""body"": ""Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}""," + "\n" +
@"    ""deliveryMethod"": ""Email""," + "\n" +
@"    ""default"": true" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}"
  method := "PUT"

  payload := strings.NewReader(`{
    "locale": "en",
    "variant": "variant_C",
    "template": {
        "id": "transaction"
    },
    "subject": "PingOne: transaction approval",
    "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "default": true
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
PUT /environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}} HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "locale": "en",
    "variant": "variant_C",
    "template": {
        "id": "transaction"
    },
    "subject": "PingOne: transaction approval",
    "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "default": true
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"locale\": \"en\",\n    \"variant\": \"variant_C\",\n    \"template\": {\n        \"id\": \"transaction\"\n    },\n    \"subject\": \"PingOne: transaction approval\",\n    \"body\": \"Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}\",\n    \"deliveryMethod\": \"Email\",\n    \"default\": true\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "locale": "en",
    "variant": "variant_C",
    "template": {
      "id": "transaction"
    },
    "subject": "PingOne: transaction approval",
    "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "default": true
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "locale": "en",
    "variant": "variant_C",
    "template": {
      "id": "transaction"
    },
    "subject": "PingOne: transaction approval",
    "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "default": true
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}"

payload = json.dumps({
  "locale": "en",
  "variant": "variant_C",
  "template": {
    "id": "transaction"
  },
  "subject": "PingOne: transaction approval",
  "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",
  "deliveryMethod": "Email",
  "default": True
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "locale": "en",\n    "variant": "variant_C",\n    "template": {\n        "id": "transaction"\n    },\n    "subject": "PingOne: transaction approval",\n    "body": "Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}",\n    "deliveryMethod": "Email",\n    "default": true\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "locale": "en",
  "variant": "variant_C",
  "template": {
    "id": "transaction"
  },
  "subject": "PingOne: transaction approval",
  "body": "Approve this transfer of \${sum} \${currency} to \${user.username}, by entering this OTP: \${OTP}",
  "deliveryMethod": "Email",
  "default": true
})

response = http.request(request)
puts response.read_body
let parameters = "{\n    \"locale\": \"en\",\n    \"variant\": \"variant_C\",\n    \"template\": {\n        \"id\": \"transaction\"\n    },\n    \"subject\": \"PingOne: transaction approval\",\n    \"body\": \"Approve this transfer of ${sum} ${currency} to ${user.username}, by entering this OTP: ${OTP}\",\n    \"deliveryMethod\": \"Email\",\n    \"default\": true\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/environments/{{envID}}/templates/{{templateName}}/contents/{{contentID}}")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

200 OK

{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication/contents/545f7640-8d21-4c84-b1c1-f37d79728a22"
        },
        "template": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/strong_authentication"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "id": "545f7640-8d21-4c84-b1c1-f37d79728a22",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2021-01-14T06:05:22.170Z",
    "updatedAt": "2021-01-14T06:07:34.661Z",
    "locale": "en-gb",
    "template": {
        "id": "strong_authentication"
    },
    "subject": "Test Email",
    "body": "I'm an email body! I'm a result of a POST request and your OTP is ${OTP}",
    "deliveryMethod": "Email",
    "default": false
}